#delimit ;

clear;
set mem 100m;
set matsize 800;

cd c:\Semiparam;

capture log close;
log using IM.log, replace;


***********************************************************;

capture program drop nlim01;
program define nlim01;

            if "`1'" == "?" {;
                global S_1 "B1 B2 B3 B4 B5 B6 B7 B8 B9 B10 B11 B12 B13 B14 B15 B16 B17 B18 B19
			    B20 B21 B22 B23 B24 B25 B26 B27 B28 B29 B30";
                global B1=b[1,1];
                global B2=b[2,1];
                global B3=b[3,1];
                global B4=b[4,1];
                global B5=b[5,1];
                global B6=b[6,1];
                global B7=b[7,1];
                global B8=b[8,1];
                global B9=b[9,1];
                global B10=b[10,1];
                global B11=b[11,1];
                global B12=b[12,1];
                global B13=b[13,1];
                global B14=b[14,1];
                global B15=b[15,1];
                global B16=b[16,1];
                global B17=b[17,1];
                global B18=b[18,1];
                global B19=b[19,1];
                global B20=b[20,1];
                global B21=b[21,1];
                global B22=b[22,1];
                global B23=b[23,1];
                global B24=b[24,1];
                global B25=b[25,1];
                global B26=b[26,1];
                global B27=b[27,1];
                global B28=b[28,1];
                global B29=b[29,1];
                global B30=b[30,1];

                exit;
            };

	tempvar y xb u Kn g1 g0 temp1_1 temp1_2 temp0_1 temp0_2;

	gen `y'=inlf;

	gen `xb'= Xeduc*$B1+Xage*$B2+Xstmarr*$B3+Xnwfinc*$B4+Xch_1_2*$B5
		+Xch_3_5*$B6+Xch_6_17*$B7+Xage2*$B8+Xnwfin2*$B9+Xhage*$B10
		+Xheduc*$B11+Xhage2*$B12+Xheduc2*$B13+Xhwkunem*$B14+Xhwkunmis*$B15
		+Xmeduc*$B16+Xmage*$B17+Xmstmarr*$B18+Xmnwfinc*$B19+Xmch_1_2*$B20
		+Xmch_3_5*$B21+Xmch_6_17*$B22+Xmage2*$B23+Xmnwfin2*$B24+Xmhage*$B25
		+Xmheduc*$B26+Xmhage2*$B27+Xmheduc2*$B28+Xmhwkunem*$B29+Xmhwkunmis*$B30;

	qui gen double `u'=.;
	qui gen double `Kn'=.;
	qui gen double `g1'=.;
	qui gen double `g0'=.;

	qui gen double `temp1_1'=0;
	qui gen double `temp1_2'=0;
	qui gen double `temp0_1'=.;
	qui gen double `temp0_2'=.;


  local i=1;

   while `i'<=N {;

      qui replace `u' = (`xb'[`i']-`xb')/h_;
      qui replace `Kn'= 1/sqrt(2*_pi)*exp(-`u'^2/2)/h_; 

      qui replace `temp1_1'=0;
      qui replace `temp1_1'=`y'*`Kn' if _n~=`i';
      qui replace `temp1_2'=sum(`temp1_1');
      qui replace `g1'=`temp1_2'[N] in `i';

      qui replace `temp0_1'=0;
      qui replace `temp0_1'=`Kn' if _n~=`i';
      qui replace `temp0_2'=sum(`temp0_1');
      qui replace `g0'=`temp0_2'[N] in `i';

   local i=`i'+1;
   };

            replace `g1'=1 if `g0'==0&`y'<=0.5;
            replace `g1'=0 if `g0'==0&`y'>0.5;
            replace `g0'=1 if `g0'==0;

            replace `1'= `g1'/`g0';
	    replace g=`1';

        end;

***********************************************************;

capture program drop im_score01;
program define im_score01;

	tempvar y xb u Kn g1 g0 temp1_1 temp1_2 temp0_1 temp0_2;

	qui gen double `y'=inlf;

	qui gen double `xb'= Xeduc*b[1,1]+Xage*b[2,1]+Xstmarr*b[3,1]+Xnwfinc*b[4,1]
		+Xch_1_2*b[5,1]+Xch_3_5*b[6,1]+Xch_6_17*b[7,1]+Xage2*b[8,1]
		+Xnwfin2*b[9,1]+Xhage*b[10,1]+Xheduc*b[11,1]+Xhage2*b[12,1]
		+Xheduc2*b[13,1]+Xhwkunem*b[14,1]+Xhwkunmis*b[15,1]
		+Xmeduc*b[16,1]+Xmage*b[17,1]+Xmstmarr*b[18,1]+Xmnwfinc*b[19,1]
		+Xmch_1_2*b[20,1]+Xmch_3_5*b[21,1]+Xmch_6_17*b[22,1]
		+Xmage2*b[23,1]+Xmnwfin2*b[24,1]+Xmhage*b[25,1]+Xmheduc*b[26,1]
		+Xmhage2*b[27,1]+Xmheduc2*b[28,1]+Xmhwkunem*b[29,1]
		+Xmhwkunmis*b[30,1];

	qui replace `xb'=XB;

	qui gen double `u'=.;
	qui gen double `Kn'=.;
	qui gen double `g1'=.;
	qui gen double `g0'=.;

	qui gen double `temp1_1'=0;
	qui gen double `temp1_2'=0;
	qui gen double `temp0_1'=.;
	qui gen double `temp0_2'=.;


  local i=1;

   while `i'<=N {;

      qui replace `u' = (`xb'[`i']-`xb')/h_;
      qui replace `Kn'= 1/sqrt(2*_pi)*exp(-`u'^2/2)/h_;

      qui replace `temp1_1'=0;
      qui replace `temp1_1'=`y'*`Kn' if _n~=`i';
      qui replace `temp1_2'=sum(`temp1_1');
      qui replace `g1'=`temp1_2'[N] in `i';

      qui replace `temp0_1'=0;
      qui replace `temp0_1'=`Kn' if _n~=`i';
      qui replace `temp0_2'=sum(`temp0_1');
      qui replace `g0'=`temp0_2'[N] in `i';

   local i=`i'+1;
   };


	    list `g0' `g1' `y' if `g0'==0;
            replace `g1'=1 if `g0'==0&`y'<=0.5;
            replace `g1'=0 if `g0'==0&`y'>0.5;
            replace `g0'=1 if `g0'==0;

	/***** Recording E(y) ****/

            replace gs = `g1'/`g0';


	local myvarlist Xeduc Xage Xstmarr Xnwfinc Xch_1_2 Xch_3_5 Xch_6_17 Xage2
		Xnwfin2 Xhage Xheduc Xhage2 Xheduc2 Xhwkunem Xhwkunmis
		Xmeduc Xmage Xmstmarr Xmnwfinc Xmch_1_2 Xmch_3_5 Xmch_6_17
		Xmage2 Xmnwfin2 Xmhage Xmheduc Xmhage2 Xmheduc2 Xmhwkunem Xmhwkunmis;

	tempvar td1_1 td1_2 td0_1 td0_2;

	qui gen double `td1_1'=0;
	qui gen double `td1_2'=0;
	qui gen double `td0_1'=0;
	qui gen double `td0_2'=0;

	capture drop gd1* gd0*;

     foreach var of varlist `myvarlist' {;
	qui gen double gd1`var'=.;
	qui gen double gd0`var'=.;
     };


  local i=1;

   while `i'<=N {;

      qui replace `u' = (`xb'[`i']-`xb')/h_;
      qui replace `Kn'= 1/sqrt(2*_pi)*exp(-`u'^2/2)/h_; 


     foreach var of varlist `myvarlist' {;

      qui replace `td1_1'=0;
      qui replace `td1_1'=`y'*(-`u')*(`var'[`i']-`var')/h_*`Kn' if _n~=`i';
      qui replace `td1_2'=sum(`td1_1');
      qui replace gd1`var'=`td1_2'[N] in `i';

      qui replace `td0_1'=0;
      qui replace `td0_1'=(-`u')*(`var'[`i']-`var')/h_*`Kn' if _n~=`i';
      qui replace `td0_2'=sum(`td0_1');
      qui replace gd0`var'=`td0_2'[N] in `i';

    };

   local i=`i'+1;
   };


   /*** L = number of regressors ***/

   scalar L=30;
   matrix S = J(L,1,0);


capture drop S*;
local scorelist;

  local k = 1;

     foreach var of varlist `myvarlist' {;

	qui gen double S`var'=.;
	qui replace S`var'= gd1`var'/`g0' - `g1'*gd0`var'/(`g0'^2);

	local scorelist `scorelist' S`var';

	qui gen double Ssum`var'=.;
	qui replace Ssum`var'=sum(S`var');
	qui mat S[`k',1]=Ssum`var'[N]/N;

     local k = `k'+1;
     };

     capture drop gd1* gd0* Ssum*;

     end;

***********************************************************;

scalar h_80 = .3;
scalar h_81 = .3333;
scalar h_82 = .1333;
scalar h_83 = .1;
scalar h_84 = .1333;
scalar h_85 = .3;
scalar h_86 = .1333;
scalar h_87 = .1333;
scalar h_88 = .1333;
scalar h_89 = .1333;
scalar h_90 = .3;
scalar h_91 = .1;
scalar h_92 = .1333;


local l=80;

   while `l'<=92 {;

      use data_orth_sorted\oyear`l'.dta, clear;
      di "";
      di "NLS, year 19"`l';

      qui sum id;
      scalar N=r(N);
      scalar h_=h_`l';
      scalar di h_;

      capture drop g*;
      qui gen g=.;
      qui gen gs=.;

      capture drop H;
      capture drop B* S*;
      capture drop XB;

	matrix b=J(30,1,1);

        global B1=b[1,1];
        global B2=b[2,1];
        global B3=b[3,1];
        global B4=b[4,1];
        global B5=b[5,1];
        global B6=b[6,1];
        global B7=b[7,1];
        global B8=b[8,1];
        global B9=b[9,1];
        global B10=b[10,1];
        global B11=b[11,1];
        global B12=b[12,1];
        global B13=b[13,1];
        global B14=b[14,1];
        global B15=b[15,1];
        global B16=b[16,1];
        global B17=b[17,1];
        global B18=b[18,1];
        global B19=b[19,1];
        global B20=b[20,1];
        global B21=b[21,1];
        global B22=b[22,1];
        global B23=b[23,1];
        global B24=b[24,1];
        global B25=b[25,1];
        global B26=b[26,1];
        global B27=b[27,1];
        global B28=b[28,1];
        global B29=b[29,1];
        global B30=b[30,1];

      nl im01 inlf, leave;
      predict XB, yhat;
      matrix b=e(b)';
      mat list b;

      im_score01;

      save, replace;

      local l=`l'+1;
   };

log close;
